from пітон.ядро import *
from .класи_загальні import ПерелікМов

class ІППереривання(BaseException):
    """
    Базовий клас переривання інтерфейсу прикладного програмування
    """
    def __init__(self, message):
        super().__init__(message)

class ІППТаймАут(ІППереривання):
    '''Переривання операція за тайм-аутом при використанні інтерфесу прикладного програмування'''
    def __init__(self, message):
        super().__init__(message)


def повідомити(контекст, рівень = 20, текст=Жоден, переривання = Жоден, укр: (строка, Жоден) = "", анг: (строка, Жоден) = ""):
    '''
    Функція реєструє, виводить повідомлення, та за потреби визиває виключення

    :param контекст:
    :param рівень (число): рівень повідомлення
        НЕ ВКАЗАНО: 0 (NOSET)
        ВІДЛАДКА: 10 (DEBUG)
        ІНФОРМАЦІЯ: 20 (INFO)
        ПОПЕРЕДЖЕННЯ: 30 (WARN)
        ПОМИЛКА: 40 (ERROR)
        КРИТИЧНО: 50 (CRITICAL)

    :param текст:
    :return:
    '''

    if переривання is not Жоден:
        рівень = 50

    if текст is not Жоден:
        інформація_для_друку = текст
    elif контекст.мова == ПерелікМов.АНГ:
        інформація_для_друку = анг
    elif контекст.мова == ПерелікМов.УКР:
        інформація_для_друку = укр

    надрукувати(інформація_для_друку)

    if рівень >= 50:
        if переривання is not Жоден:
            raise переривання(інформація_для_друку)
        else:
            raise Exception(інформація_для_друку)


APIException = ІППереривання
TimeoutError = ІППТаймАут